<?php 
/* Travel Connector - Ipay88 Payment Plugin for VirtueMart V2.0
 * @author		Alex Wai | Travel Connector
 * @version		2.0.4
 * @package		VirtueMart
 * @subpackage	Payment
 * @copyright	Copyright (C) Travel Connector 2010. All rights reserved.
 * @license		Commercial License VM 2.0 Payment Plugin */
 
/* No direct access */
defined('_JEXEC') or die;

/* Use for Debug */
if(!function_exists('dump')) 
{
	function dump($obj='',$section='Default')
	{
	/* ADD Debug Code Here */
	} 
}

/* Check If Plugin Class Loaded */
if (!class_exists('vmPSPlugin')) { require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php'); }

class plgVmPaymentIPay88 extends vmPSPlugin {

	/* Instance of class */
	public static 	$_this 		= false;
	protected 		$version	= '2.0';

	function __construct(& $subject, $config) {
		parent::__construct($subject, $config);

		$this->_loggable 		= true;
		$this->tableFields 		= array_keys($this->getTableSQLFields());
		$this->_tablepkey 		= 'id'; 
		$this->_tableId 		= 'id'; 
		$fieldPush = array(
	    'payment_logo' 			=> array(''	, 'char'),
	    'ipay88_merchant_code' 	=> array(''	, 'char'),
	    'ipay88_merchant_key' 	=> array(''	, 'char'),
	    'ipay88_request_url' 	=> array(''	, 'char'),
	    'ipay88_response_url' 	=> array(''	, 'char'),
		'ipay88_sandbox' 		=> array(0	, 'int'),
	    'ipay88_encoding' 		=> array(0	, 'int'),
	    'ipay88_payment_id' 	=> array(0	, 'int'),
	    'payment_currency'		=> array(0	, 'int'),
	    'country' 				=> array(''	, 'char'),
		'ipay88_transaction_fee'=> array(''	, 'int'),
	    'debug' 				=> array(0	, 'int'),
	    'status_pending' 		=> array(''	, 'char'),
	    'status_success' 		=> array(''	, 'char'),
	    'status_canceled' 		=> array(''	, 'char'),
		);
		$this->setConfigParameterable($this->_configTableFieldName, $fieldPush);
	}

	public function getVmPluginCreateTableSQL() {
	dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
		return $this->createTableSQL('Payment IPay88 Table');
	}

	function getTableSQLFields() {
	dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
		$SQLfields = array(
	    'id' 									=> ' INT(11) unsigned NOT NULL AUTO_INCREMENT ',
	    'virtuemart_order_id' 					=> ' int(1) UNSIGNED DEFAULT NULL',
	    'order_number' 							=> ' char(32) DEFAULT NULL',
	    'virtuemart_paymentmethod_id' 			=> ' mediumint(1) UNSIGNED DEFAULT NULL',
	    'payment_name' 							=> ' TEXT  ',
	    'payment_order_total'					=> ' decimal(15,5) NOT NULL DEFAULT \'0.00000\' ',
	    'payment_currency' 						=> ' char(3) ',
	    'ipay88_response_merchant_code' 		=> ' TEXT  ',
	    'ipay88_response_payment_id' 			=> ' TEXT  ',
	    'ipay88_response_reference_no' 			=> ' TEXT  ',
	    'ipay88_response_amount' 				=> ' TEXT  ',
	    'ipay88_response_currency' 				=> ' TEXT  ',
	    'ipay88_response_remark' 				=> ' TEXT  ',
	    'ipay88_response_transaction_id' 		=> ' TEXT  ',
	    'ipay88_response_authorization_code' 	=> ' TEXT  ',
	    'ipay88_response_payment_status' 		=> ' TEXT  ',
	    'ipay88_response_error_description' 	=> ' TEXT  ',
	    'ipay88_response_signature' 			=> ' TEXT  ',
	    'ipay88_response_custom' 				=> ' TEXT  ',
	    'ipay88_response_log' 					=> ' TEXT  ',
		'ipay88_request_merchant_code' 			=> ' TEXT  ',
		'ipay88_request_payment_id' 			=> ' TEXT  ',
		'ipay88_request_reference_no' 			=> ' TEXT  ',
		'ipay88_request_amount' 				=> ' TEXT  ',
		'ipay88_request_currency' 				=> ' TEXT  ',
		'ipay88_request_product_description'	=> ' TEXT  ',
		'ipay88_request_user_name' 				=> ' TEXT  ',
		'ipay88_request_user_email' 			=> ' TEXT  ',
		'ipay88_request_user_contact' 			=> ' TEXT  ',
		'ipay88_request_remark' 				=> ' TEXT  ',
		'ipay88_request_lang' 					=> ' TEXT  ',
		'ipay88_request_signature' 				=> ' TEXT  ',
		'ipay88_request_response_url' 			=> ' TEXT  ',
		'ipay88_request_log' 					=> ' TEXT  ',
		);
		return $SQLfields;
	}
	
	function plgVmConfirmedOrder($cart, $order) {
		dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
		dump($cart	, 'cart'	);
		dump($order	, 'order'	);
	
		if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
			return null; 
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return false;
		}
		$session 			= JFactory::getSession();
		$return_context 	= $session->getId();
		$this->_debug 		= $method->debug;
		$this->logInfo('plgVmConfirmedOrder order number: ' . $order['details']['BT']->order_number, 'message');

		if (!class_exists('VirtueMartModelOrders'))		{ require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' ); }
		if (!class_exists('VirtueMartModelCurrency'))	{ require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'currency.php'); }

		$new_status 		= '';
		$usrBT 				= $order['details']['BT'];
		$address 			= ((isset($order['details']['ST'])) ? $order['details']['ST'] : $order['details']['BT']);

		if (!class_exists('TableVendors'))				{ require(JPATH_VM_ADMINISTRATOR . DS . 'table' . DS . 'vendors.php'); }

		$vendorModel 		= VmModel::getModel('Vendor');
		$vendorModel		->setId(1);
		$vendor 			= $vendorModel->getVendor();
		$vendorModel		->addImages($vendor, 1);
		$this				->getPaymentCurrency($method);
		$currency_query 	= 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
		$db 				= &JFactory::getDBO();
		$db    				->setQuery($currency_query);
		$currency_code_3 	= $db->loadResult(); 										/*Return Result MYR*/
		$paymentCurrency 	= CurrencyDisplay::getInstance($method->payment_currency);	/*Return Currency Object*/
		$totalInPaymentCurrency = str_replace(',','',number_format($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total, false),'2','',''));
		$cd 				= CurrencyDisplay::getInstance($cart->pricesCurrency);
		
		
		/* Payment Pre Post : */ 
		
		//$languageTag 			= $this->getLanguageTag();
		$merchantCode			= $method->ipay88_merchant_code;
		$merchantKey			= $method->ipay88_merchant_key;
		//$url 					= $method->ipay88_request_url;
		
		$post_variables = Array(
		'MerchantCode'			=> $method->ipay88_merchant_code,
		'PaymentId'				=> $method->ipay88_payment_id,
		'RefNo'					=> $order['details']['BT']->order_number,
		'Amount'				=> $totalInPaymentCurrency,
	    'Currency' 				=> $currency_code_3,
		'ProdDesc' 				=> $order['details']['BT']->order_number,
		'UserName' 				=> trim($order['details']['BT']->first_name.' '.$order['details']['BT']->middle_name.' '.$order['details']['BT']->last_name),
		'UserEmail'				=> $order['details']['BT']->email,
		'UserContact'			=> $order['details']['BT']->phone_1,
		'Remark'				=> $return_context,
		'Lang'					=> $this->_getEncoding($method->ipay88_encoding),
		'Signature'				=> $this->_getRequestSignature($method,$order['details']['BT'],$totalInPaymentCurrency,$currency_code_3),
		'ResponseURL'			=> JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&on=' . $order['details']['BT']->order_number . '&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id),
		'BackendURL"'			=> JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&format=raw&mode=backend&on=' . $order['details']['BT']->order_number . '&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id),
		);		
		dump($post_variables, 'post_variables');
		dump('----------------------------');

		/* Prepare data that should be stored in the database */

		$dbValues['virtuemart_order_id'] 				= $usrBT->virtuemart_order_id;
		$dbValues['order_number'] 						= $order['details']['BT']->order_number;
		$dbValues['payment_name'] 						= $this->renderPluginName($method, $order);
		$dbValues['virtuemart_paymentmethod_id'] 		= $cart->virtuemart_paymentmethod_id;
		$dbValues['payment_currency'] 					= $method->payment_currency;
		$dbValues['payment_order_total'] 				= $post_variables['Amount'];
		$dbValues['ipay88_response_custom'] 			= $return_context;		
		$dbValues['ipay88_request_merchant_code'] 		= $post_variables['MerchantCode'];
		$dbValues['ipay88_request_payment_id'] 			= $post_variables['PaymentId'];
		$dbValues['ipay88_request_reference_no'] 		= $post_variables['RefNo'];
		$dbValues['ipay88_request_amount'] 				= $post_variables['Amount'];
		$dbValues['ipay88_request_currency'] 			= $post_variables['Currency'];
		$dbValues['ipay88_request_product_description']	= $post_variables['ProdDesc'];
		$dbValues['ipay88_request_user_name'] 			= $post_variables['UserName'];
		$dbValues['ipay88_request_user_email'] 			= $post_variables['UserEmail'];
		$dbValues['ipay88_request_user_contact'] 		= $post_variables['UserContact'];
		$dbValues['ipay88_request_remark'] 				= $return_context;
		$dbValues['ipay88_request_lang'] 				= $post_variables['Lang'];
		$dbValues['ipay88_request_signature'] 			= $post_variables['Signature'];
		$dbValues['ipay88_request_response_url'] 		= $post_variables['ResponseURL'];
		$dbValues['ipay88_request_log'] 				= serialize($post_variables);
		
		dump($dbValues, 'dbValues');
		dump('----------------------------');
		
		$this->storePSPluginInternalData($dbValues);
		
		$url = $this->_getiPay88Url ($method);

		/* Create Custom Payment Form */
		
		$html	= '<html><head><title>Redirection</title></head><body><div style="margin: auto; text-align: center;">';
		$html	.= '<form action="' . "https://" . $url . "/epayment/entry.asp" . '" method="post" name="vm_ipay88_form" >';
		$html	.= 'Please wait while connecting to Payment Gateway.....<br />';
		$html	.= '<br />';
		$html	.= '<input type="submit"  value="'.JText::_('VMPAYMENT_IPAY88_REDIRECT_MESSAGE').'" />';
		foreach ($post_variables as $name => $value) 
		{
			$html.= '<input type="hidden" name="' . $name . '" value="' . htmlspecialchars($value) . '" />';
		}
		$html.= '</form></div>';
		$html.= ' <script type="text/javascript">';
		$html.= ' document.vm_ipay88_form.submit();';
		$html.= ' </script></body></html>';
		return $this->processConfirmedOrderPaymentResponse(2, $cart, $order, $html, $dbValues['payment_name'], $new_status);

	}


	function _getiPay88Url ($method) {

		$url = $method->ipay88_sandbox ? 'sandbox.ipay88.co.id' : 'payment.ipay88.co.id';
		
		return $url;
	}

	/**
	 * @param $method
	 * @return string
	 */
	// function _getiPay88UrlHttps ($method) {

		// $url = $this->_getiPay88Url ($method);
		// $url = $url . '/epayment/entry.asp';

		// return $url;
	// }
	
	function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId) {
	dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
			return null; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return false;
		}
		$this->getPaymentCurrency($method);
		$paymentCurrencyId = $method->payment_currency;
	}

	function plgVmOnPaymentResponseReceived(&$html) {
		dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
		
		$ipay88_data 					= JRequest::get ( 'post', JREQUEST_ALLOWRAW );
		$virtuemart_paymentmethod_id 	= JRequest::getInt('pm', 0);
		$order_number 					= JRequest::getVar('RefNo', 0);
		$vendorId 						= 0;
		$app 							= JFactory::getApplication();		

		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) 	{ return null; }		
		if (!$this->selectedThisElement($method->payment_element)) 					{ return false;}
		if (!class_exists('VirtueMartCart'))		{ require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');}
		if (!class_exists('shopFunctionsF'))		{ require(JPATH_VM_SITE . DS . 'helpers' . DS . 'shopfunctionsf.php');}
		if (!class_exists('VirtueMartModelOrders'))	{ require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );}
		
		$payment_name 			= $this->renderPluginName($method);		
		
		if (!empty($ipay88_data)) 
		{
			vmdebug('plgVmOnPaymentResponseReceived', $ipay88_data);
			if ($ipay88_data['Status'] != '0') 
			{
				dump($ipay88_data['Status'], 'status no error');
				$order_number 			= $ipay88_data['RefNo'];
				$return_context 		= $ipay88_data['Remark'];
				
				if (!class_exists('VirtueMartModelOrders')){require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );}
				
				
				// Verify Postback Signature
				$postback				= $this->_getResponseSignature($method,$ipay88_data);
				
				$virtuemart_order_id 	= VirtueMartModelOrders::getOrderIdByOrderNumber($order_number);
				$payment_name 			= $this->renderPluginName($method);
				
				if (isset($virtuemart_order_id)) 
				{
					if($postback)
					{
						$order['customer_notified']	= 1;
						$order['order_status'] 		= $this->_getPaymentStatus($method,$ipay88_data, $ipay88_data['Status']);
						
						$order['comments'] 			= JText::sprintf('VMPAYMENT_IPAY88_PAYMENT_STATUS_CONFIRMED', $order_number);
						/* Send Email for Confirmed Payment */
						
						$modelOrder 				= VmModel::getModel('orders');
						$orderitems 				= $modelOrder->getOrder($virtuemart_order_id);
						$nb_history 				= count($orderitems['history']);
						
						if (($orderitems['history'][$nb_history - 1]->order_status_code != $order['order_status'])) 
						{
							
							$this ->_storeIPay88InternalData($method, $ipay88_data, $virtuemart_order_id);
							$order['virtuemart_order_id'] 	= $virtuemart_order_id;
							$order['comments'] 				= JText::sprintf('VMPAYMENT_IPAY88_EMAIL_SENT');
							$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, true);

							$msg			= JText::_('VMPAYMENT_IPAY88_PAYMENT_STATUS_SUCCESS') ;
							$app->enqueueMessage($msg, 'success');
							if (JRequest::getVar('mode') == 'backend' && JRequest::getVar('format') == 'raw' ){$cart = VirtueMartCart::getCart();$cart->emptyCart();$this->_getBackendPost('OK');}
							return;
						}
					}
					else
					{
						// if Signature not match // perform requery to check
						$modelOrder 					= VmModel::getModel('orders');
						$orderitems 					= $modelOrder->getOrder($virtuemart_order_id);
						$order['order_status'] 			= $this->_getPaymentRequeryStatus($method,$ipay88_data, $ipay88_data['Status']);
						$order['customer_notified']		= 0;
						$order['virtuemart_order_id'] 	= $virtuemart_order_id;
						
							if ($order['order_status'] == 'C')
							{
								$order['comments'] 				= JText::sprintf('VMPAYMENT_IPAY88_PAYMENT_STATUS_CONFIRMED', $order_number);
								$msg							= JText::_('VMPAYMENT_IPAY88_PAYMENT_STATUS_CONFIRMED') ;
								$app->enqueueMessage($msg, 'success');
								if (JRequest::getVar('mode') == 'backend' && JRequest::getVar('format') == 'raw' ){$this->_getBackendPost('OK');}
								
							}
							else
							{
								$order['order_status'] 			= 'P';
								$order['comments'] 				= JText::sprintf('VMPAYMENT_IPAY88_PAYMENT_STATUS_PENDING', $order_number);
								$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, true);
								$msg			= JText::_('VMPAYMENT_IPAY88_PAYMENT_STATUS_PENDING') ;
								$app->enqueueMessage($msg, 'error');
								if (JRequest::getVar('mode') == 'backend' && JRequest::getVar('format') == 'raw' ){$this->_getBackendPost('FAIL');}
								return;
							}
						
					}
				}
				else 
				{
					$msg			= JText::_('VMPAYMENT_IPAY88_PAYMENT_STATUS_NO_ORDER') . $errorCode ;
					$app->enqueueMessage($msg, 'error');
					if (JRequest::getVar('mode') == 'backend' && JRequest::getVar('format') == 'raw' ){$this->_getBackendPost('FAIL');}
					return;
				}
			} 
			else 
			{
				$order_number 			= $ipay88_data['RefNo'];
				if (!class_exists('VirtueMartModelOrders')){require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );}
				$virtuemart_order_id 	= VirtueMartModelOrders::getOrderIdByOrderNumber($order_number);
				dump($ipay88_data['Status'], 'status error');
				$this ->_storeIPay88InternalData($method, $ipay88_data, $virtuemart_order_id);
				$errorCode 		= $ipay88_data['ErrDesc'];
				$errorMessage	= $ipay88_data['ErrDesc'];
				$msg			= JText::_('VMPAYMENT_IPAY88_ERROR_IPAY88_RESPONSE') . $errorCode ;
				$app->enqueueMessage($msg, 'error');
				if (JRequest::getVar('mode') == 'backend' && JRequest::getVar('format') == 'raw' ){$this->_getBackendPost('FAIL');}
				return;
			}
		} 
		else 
		{
				if (!class_exists('VirtueMartModelOrders')){require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );}
				$virtuemart_order_id 	= VirtueMartModelOrders::getOrderIdByOrderNumber($order_number);
				$msg			= JText::_('VMPAYMENT_IPAY88_PAYMENT_STATUS_UNKNOWN') ;
				$app->enqueueMessage($msg, 'error');
				if (JRequest::getVar('mode') == 'backend' && JRequest::getVar('format') == 'raw' ){$this->_getBackendPost('FAIL');}
				return;
		}
		$queue		= $app->getMessageQueue();
		
		
		
		
		if (count($queue) <= 0)
		{
			$msg			= JText::_('VMPAYMENT_IPAY88_PAYMENT_STATUS_INFORMATION') ;
			$app->enqueueMessage($msg, 'message');
		}
		
		
		if (!($paymentTable = $this->_getIPay88InternalData($virtuemart_order_id, $order_number) )) {
			return '';
		}

		
		$html = $this->_getPaymentResponseHtml($paymentTable, $payment_name);
		$cart = VirtueMartCart::getCart();
		$cart->emptyCart();
		return true;
	}
	
	function _getBackendPost($status){
	$link = JROUTE::_(JURI::root() . 'plugins/vmpayment/ipay88/ipay88.status.php?status='.$status);
	header('Location: '.$link);
	exit();
	}
	
	function _storeIPay88InternalData($method, $ipay88_data, $virtuemart_order_id) {  
		dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
		
		/* Retrieve Field of Table */
		$db 		= JFactory::getDBO();
		$query 		= 'SHOW COLUMNS FROM `' . $this->_tablename . '` ';
		$db  		->setQuery($query);
		$columns 	= $db->loadResultArray(0);
		$post_msg 	= '';
		
		$q = 'SELECT * FROM `' . $this->_tablename . '` '. 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
		$db->setQuery($q);
		$prev = $db->loadObject();
		
		dump($virtuemart_order_id,'demo prev');
		
		foreach ($ipay88_data as $key => $value) {$post_msg .= $key . "=" . $value . "<br />";}
		
		$response_fields['payment_name'] 						= $this->renderPluginName($method);
		$return_context 										= $ipay88_data['Remark'];
		$response_fields['order_number'] 						= $ipay88_data['RefNo'];
		$response_fields['virtuemart_order_id'] 				= $virtuemart_order_id;
		$response_fields['ipay88_response_merchant_code'] 		= $ipay88_data['MerchantCode'];
		$response_fields['ipay88_response_payment_id'] 			= $ipay88_data['PaymentId'];
		$response_fields['ipay88_response_reference_no'] 		= $ipay88_data['RefNo'];
		$response_fields['ipay88_response_amount'] 				= $ipay88_data['Amount'];
		$response_fields['ipay88_response_currency'] 			= $ipay88_data['Currency'];
		$response_fields['ipay88_response_remark'] 				= $ipay88_data['Remark'];
		$response_fields['ipay88_response_transaction_id'] 		= $ipay88_data['TransId'];
		$response_fields['ipay88_response_authorization_code']	= $ipay88_data['AuthCode'];
		$response_fields['ipay88_response_payment_status'] 		= $ipay88_data['Status'];
		$response_fields['ipay88_response_error_description']	= $ipay88_data['ErrDesc'];
		$response_fields['ipay88_response_signature'] 			= $ipay88_data['Signature'];
		$response_fields['ipay88_response_log'] 				= $post_msg;
		
		
		
		if(!empty($prev->ipay88_request_merchant_code)) 	{$response_fields['ipay88_request_merchant_code'] 		= $prev->ipay88_request_merchant_code;}
		if(!empty($prev->ipay88_request_payment_id)) 		{$response_fields['ipay88_request_payment_id'] 			= $prev->ipay88_request_payment_id;}
		if(!empty($prev->ipay88_request_reference_no)) 		{$response_fields['ipay88_request_reference_no'] 		= $prev->ipay88_request_reference_no;}
		if(!empty($prev->ipay88_request_amount))  			{$response_fields['ipay88_request_amount'] 				= $prev->ipay88_request_amount;}
		if(!empty($prev->ipay88_request_currency)) 			{$response_fields['ipay88_request_currency'] 			= $prev->ipay88_request_currency;}
		if(!empty($prev->ipay88_request_product_description)){$response_fields['ipay88_request_product_description'] = $prev->ipay88_request_product_description;}
		if(!empty($prev->ipay88_request_user_name)) 		{$response_fields['ipay88_request_user_name'] 			= $prev->ipay88_request_user_name;}
		if(!empty($prev->ipay88_request_user_email)) 		{$response_fields['ipay88_request_user_email'] 			= $prev->ipay88_request_user_email;}
		if(!empty($prev->ipay88_request_user_contact)) 		{$response_fields['ipay88_request_user_contact'] 		= $prev->ipay88_request_user_contact;}
		if(!empty($prev->ipay88_request_remark)) 			{$response_fields['ipay88_request_remark'] 				= $prev->ipay88_request_remark;}
		if(!empty($prev->ipay88_request_lang)) 				{$response_fields['ipay88_request_lang'] 				= $prev->ipay88_request_lang;}
		if(!empty($prev->ipay88_request_signature))  		{$response_fields['ipay88_request_signature'] 			= $prev->ipay88_request_signature;}
		if(!empty($prev->ipay88_request_response_url)) 		{$response_fields['ipay88_request_response_url'] 		= $prev->ipay88_request_response_url;}
		if(!empty($prev->ipay88_request_log)) 				{$response_fields['ipay88_request_log'] 				= $prev->ipay88_request_log;}
		if(!empty($prev->payment_order_total)) 				{$response_fields['payment_order_total'] 				= $prev->payment_order_total;}
		if(!empty($prev->payment_currency)) 				{$response_fields['payment_currency'] 					= $prev->payment_currency;}
		
		
		dump($method,'response');
		
		$this->storePSPluginInternalData($response_fields, 'virtuemart_order_id', true);
	}
	
	function _getPaymentStatus($method, $response, $status)  {  
		dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
		$new_status = '';
		if (strcmp($status, '1') == 0) 
		{
			$new_status = $method->status_success;
			//$new_status = $method->status_pending;
		} 
		else 
		{
			$new_status = $method->status_canceled;
		}
		dump($status, 'status');
		dump($new_status, 'new_status');
		return $new_status;
	}	
	
	function _getPaymentRequeryStatus($method, $response, $status)  {  
		dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
		$new_status = '';
		if (strcmp($status, '1') == 0) 
		{
			$requery 	= $this->_getPaymentRequery($method->ipay88_merchant_code,$response['RefNo'],str_replace(',','',$response['Amount']));
			
			if ($requery == '00')
			{
				$new_status = $method->status_success;
			}
			else
			{
				$new_status = $method->status_pending;
			}
			
		} 
		else 
		{
			$new_status = $method->status_canceled;
		}
		dump($status, 'status');
		dump($new_status, 'new_status');
		return $new_status;
	}
	
	function _getIPay88InternalData($virtuemart_order_id, $order_number='') {  
	dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
		$db = JFactory::getDBO();
		$q = 'SELECT * FROM `' . $this->_tablename . '` WHERE ';
		if ($order_number) {
			$q .= " `order_number` = '" . $order_number . "'";
		} else {
			$q .= ' `virtuemart_order_id` = ' . $virtuemart_order_id;
		}

		$db->setQuery($q);
		if (!($paymentTable = $db->loadObject())) { return ''; }
		return $paymentTable;
	}	
	
	function _getPaymentResponseHtml($ipay88Table, $payment_name) { 
		dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
		$html = '<table style="width:100%;">' . "\n";
		$html .= $this->getHtmlRow('IPAY88_PAYMENT_NAME', $payment_name);
		if (!empty($ipay88Table)) 
		{
			$html .= $this->getHtmlRow('IPAY88_ORDER_NUMBER', $ipay88Table->order_number);
			if ($ipay88Table->ipay88_response_amount > 0)
			{
			$html .= $this->getHtmlRow('IPAY88_RESPONSE_AMOUNT', $ipay88Table->ipay88_response_currency.' '.$ipay88Table->ipay88_response_amount);
			}	
			if ($ipay88Table->ipay88_response_transaction_id != '')
			{
			$html .= $this->getHtmlRow('IPAY88_RESPONSE_TRANSACTION_ID', $ipay88Table->ipay88_response_transaction_id);
			}	
			if ($ipay88Table->ipay88_response_authorization_code != '')
			{
			$html .= $this->getHtmlRow('IPAY88_RESPONSE_AUTHORIZATION_CODE', $ipay88Table->ipay88_response_authorization_code);
			}
		}
		$html .= "</table> \n";
		return $html;
	}	

	function _getEncoding($encodeId) { 
	dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
		if ($encodeId == 0)
		{ $encoding = 'ISO-8859-1'; }
		else if ($encodeId == 1)
		{ $encoding = 'UTF-8'; }
		else if ($encodeId == 2)
		{ $encoding = 'GB2312'; }
		else if ($encodeId == 3)
		{ $encoding = 'GD18030'; }
		else if ($encodeId == 4)
		{ $encoding = 'BIG5'; }
		else
		{ $encoding = 'UTF-8'; }
		return $encoding;
	}
	
	function _getRequestSignature($ses,$order,$total,$cur){
	dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');	
		$MerchantCode		= $ses->ipay88_merchant_code;
		$MerchantKey		= $ses->ipay88_merchant_key;
		$RefNo				= $order->order_number;
		$Amount				= str_replace('.','',$total);
		$Currency			= $cur;
		$signature 			= $this->_getIPay88_signature($MerchantKey.$MerchantCode.$RefNo.$Amount.$Currency);
		
		return $signature;
	}
	
	function _getResponseSignature($method,$ipay88_data){ 
	dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
	/* Perform Signature Check */
	
	$MerchantKey 	= $method->ipay88_merchant_key;
	$MerchantCode 	= $ipay88_data['MerchantCode'];
	$PaymentId 		= $ipay88_data['PaymentId'];
	$RefNo 			= $ipay88_data['RefNo'];
	$Amount 		= str_replace('.','',str_replace(',','',$ipay88_data['Amount']));
	$Currency 		= $ipay88_data['Currency'];
	$Status 		= $ipay88_data['Status'];
	$verify			= $this->_getIPay88_signature($MerchantKey.$MerchantCode.$PaymentId.$RefNo.$Amount.$Currency.$Status);

		if ($verify == $ipay88_data['Signature'])
		{
			return true;
		}
		else
		{
			return false;
		}
	}

	function _getPaymentRequery($MerchantCode,$RefNo,$Amount){ 
	dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
	$query 		= 'https://payment.ipay88.co.id/epayment/enquiry.asp?MerchantCode='.$MerchantCode.'&RefNo='.str_replace(" ","%20",$RefNo).'&Amount='.$Amount;
	
	$url 		= parse_url($query);
	$host 		= $url["host"];
	$path 		= $url["path"] . "?" . $url["query"];
	$timeout 	= 2;
	$fp			= fsockopen ($host, 80, $errno, $errstr, $timeout);
	
		if ($fp) 
		{
			fputs ($fp, "GET $path HTTP/1.0\nHost: " . $host . "\n\n");
			while (!feof($fp)) { $buf .= fgets($fp, 128); }
			$lines = explode("\n", $buf);
			$result = $lines[count($lines)-1];
			fclose($fp);
		} 
		else { return 'Payment fail'; }
		
	return $result;
	}
	
	function _getIPay88_signature($source) { 
	dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
	  return base64_encode($this->_getHex2bin(sha1($source)));
	}
	
	function _getHex2bin($hexSource){ 
	dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
		for ($i=0;$i<strlen($hexSource);$i=$i+2)
		{
		  $bin .= chr(hexdec(substr($hexSource,$i,2)));
		}
	  return $bin;
	}
	
	/* Previous */
	function _getTablepkeyValue($virtuemart_order_id) {
	dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
		$db = JFactory::getDBO();
		$q = 'SELECT ' . $this->_tablepkey . ' FROM `' . $this->_tablename . '` '
		. 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
		$db->setQuery($q);

		if (!($pkey = $db->loadResult())) {
			JError::raiseWarning(500, $db->getErrorMsg());
			return '';
		}
		return $pkey;
	}
	
	function checkConditions($cart, $method, $cart_prices) {
	dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');

		$address = (($cart->ST == 0) ? $cart->BT : $cart->ST);

		$amount 		= $cart_prices['salesPrice'];
		$amount_cond 	= ($amount >= $method->min_amount AND $amount <= $method->max_amount
		OR
		($method->min_amount <= $amount AND ($method->max_amount == 0) ));

		$countries = array();
		if (!empty($method->countries)) {
			if (!is_array($method->countries)) {
				$countries[0] = $method->countries;
			} else {
				$countries = $method->countries;
			}
		}
		if (!is_array($address)) {
			$address = array();
			$address['virtuemart_country_id'] = 0;
		}
		if (!isset($address['virtuemart_country_id']))
		$address['virtuemart_country_id'] = 0;
		if (in_array($address['virtuemart_country_id'], $countries) || count($countries) == 0) {
			if ($amount_cond) {
				return true;
			}
		}
		return false;
	}
			 
	function plgVmOnShowOrderBEPayment($virtuemart_order_id, $payment_method_id) {
	dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
		if (!$this->selectedThisByMethodId($payment_method_id)) {
			return null; // Another method was selected, do nothing
		}

		if (!($paymentTable = $this->_getIPay88InternalData($virtuemart_order_id) )) {
			return '';
		}

		$this->getPaymentCurrency($paymentTable);
		$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $paymentTable->payment_currency . '" ';
		$db = &JFactory::getDBO();
		$db->setQuery($q);
		$currency_code_3 = $db->loadResult();
		$html = '<table class="adminlist">' . "\n";
		$html .=$this->getHtmlHeaderBE();
		$html .= $this->getHtmlRowBE('IPAY88_PAYMENT_NAME', $paymentTable->payment_name);
		$code = "ipay88_response_";
		foreach ($paymentTable as $key => $value) {
			if (substr($key, 0, strlen($code)) == $code) {
				$html .= $this->getHtmlRowBE($key, $value);
			}
		}
		$html .= '</table>' . "\n";
		return $html;
	}
	
	function plgVmOnPaymentNotification() {
	dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
		if (!class_exists('VirtueMartModelOrders'))
		require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
		$ipay88_data = JRequest::get('post');
		if (!isset($ipay88_data['invoice'])) {
			return;
		}
		$order_number = $ipay88_data['invoice'];
		$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($ipay88_data['invoice']);
		if (!$virtuemart_order_id) {
			return;
		}
		$vendorId = 0;
		$payment = $this->getDataByOrderId($virtuemart_order_id);

		$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
		if (!$this->selectedThisElement($method->payment_element)) {
			return false;
		}

		$this->_debug = $method->debug;
		if (!$payment) {
			$this->logInfo('getDataByOrderId payment not found: exit ', 'ERROR');
			return null;
		}
		$this->logInfo('ipay88_data ' . implode('   ', $ipay88_data), 'message');

		$this->_storeIPay88InternalData($method, $ipay88_data, $virtuemart_order_id);

		$error_msg = $this->_processIPN($ipay88_data, $method, $virtuemart_order_id);
		$this->logInfo('process IPN ' . $error_msg, 'message');
		if (!(empty($error_msg) )) {
			$new_status = $method->status_canceled;
			$this->logInfo('process IPN ' . $error_msg . ' ' . $new_status, 'ERROR');
		} else {
			$this->logInfo('process IPN OK', 'message');
		}
		
		if (empty($ipay88_data['payment_status']) || ($ipay88_data['payment_status'] != 'Completed' && $ipay88_data['payment_status'] != 'Pending')) {
			//return false;
		}

		$new_status = $this->_getPaymentStatus($method, $ipay88_data['payment_status']);
		$modelOrder = VmModel::getModel('orders');

		$order = array();
		$order['order_status'] = $new_status;
		$order['customer_notified'] = 1;
		$order['comments'] = JText::sprintf('VMPAYMENT_IPAY88_PAYMENT_STATUS_CONFIRMED', $order_number);

		$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, true);

		$this->logInfo('Notification, sentOrderConfirmedEmail ' . $order_number . ' ' . $new_status, 'message');

		$this->emptyCart($return_context);
	}

	/* Currently Disable & Reserved : Expand it as you like */
	/*Disabled Option Cancel Function*/
	function plgVmOnUserPaymentCancel() {  
	dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
		if (!class_exists('VirtueMartModelOrders')){require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );}
		$order_number 	= JRequest::getVar('on');
		if (!$order_number){ return false;}
		
		$db = JFactory::getDBO();
		$query = 'SELECT ' . $this->_tablename . '.`virtuemart_order_id` FROM ' . $this->_tablename . " WHERE  `order_number`= '" . $order_number . "'";

		$db->setQuery($query);
		$virtuemart_order_id = $db->loadResult();

		if (!$virtuemart_order_id) { return null; }
		$this->handlePaymentUserCancel($virtuemart_order_id);
		return true;
	}
	function getCosts(VirtueMartCart $cart, $method, $cart_prices) {
	dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
		/*Code this section to apply transaction service charge */
		return (0);
	}	
	function plgVmonShowOrderPrintPayment($order_number, $method_id) {
	dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
		return $this->onShowOrderPrint($order_number, $method_id);
	}	
	function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {
	dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
		return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
	}
	function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array()) {
	dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
		return $this->onCheckAutomaticSelected($cart, $cart_prices);
	}
	function plgVmOnStoreInstallPaymentPluginTable($jplugin_id) {
	dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
		return $this->onStoreInstallPluginTable($jplugin_id);
	}
	function plgVmOnSelectCheckPayment(VirtueMartCart $cart) {
	dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
		return $this->OnSelectCheck($cart);
	}
	function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
	dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
		return $this->displayListFE($cart, $selected, $htmlIn);
	}
	function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {
	dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
		$this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
	}
	function plgVmDeclarePluginParamsPayment($name, $id, &$data) {
	dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
		return $this->declarePluginParams('payment', $name, $id, $data);
	}
	function plgVmSetOnTablePluginParamsPayment($name, $id, &$table) {
	dump(__CLASS__.'::'.__FUNCTION__.' is triggered!');
		return $this->setOnTablePluginParams($name, $id, $table);
	}

}